!= Module HistoryFileIO
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: historyfileio2.f90,v 1.1 2011-04-05 14:46:54 sugiyama Exp $ 
! Tag Name::  $Name: arare4-20110603 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ե. Ĺ֥ƥåפͤ.
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module HistoryAutoFileIO
  !
  !ե. Ĺ֥ƥåפͤ.
  !

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &    ! ټ¿. Double precision. 
    &                 STRING, &  ! ʸ.       Strings. 
    &                 TOKEN      ! .   Keywords. 

  use gridset,  only: x_X,               &!X ɸ(顼ʻ)
    &                 z_Z,               &!Z ɸ(顼ʻ)
    &                 FileNX,            &!X γʻ(ե)
    &                 FileNZ,            &!Z γʻ(ե)
    &                 FileXMin,          &!X β(ե)
    &                 FileXMax,          &!X ξ(ե)
    &                 FileZMin,          &!Z β(ե)
    &                 FileZMax            !Z ξ(ե)
  use fileset,  only: DefaultFilePrefix, &!ҥȥե̾
    &                 exptitle,          &!ǡɽ
    &                 expsrc,            &!ǡ
    &                 expinst,           &!ǽѹԡȿ
    &                 FileNum             !ҥȥեο
  
  !ۤηػ
  implicit none
  
  !°λ
  private

  !³
  public HistoryFileAutoOpen
  public HistoryFileAutoClose

  ! ѿ
  ! Private variables
  !
  character(*), parameter:: module_name = 'history_file_io'
                              ! ⥸塼̾. 
                              ! Module name
  character(*), parameter:: version = &
    & '$Name: arare4-20110603 $' // &
    & '$Id: historyfileio2.f90,v 1.1 2011-04-05 14:46:54 sugiyama Exp $'
                              ! ⥸塼ΥС
                              ! Module version

  ! INTERFACE ʸ ; INTERFACE statements
  !
  interface HistoryFileAutoOpen
    module procedure HistoryFileAutoOpen
  end interface

  interface HistoryFileAutoClose
    module procedure HistoryFileAutoClose
  end interface

contains 

!!!------------------------------------------------------------------------
  subroutine HistoryFileAutoOpen( RestartTime, cfgfile ) 
    !
    ! history_file_io ⥸塼νԤޤ. 
    !--
    ! NAMELIST#history_file_io_nml ɤ߹ߤϤμ³ǹԤޤ. 
    !++
    !
    ! "history_file_io" module is initialized. 
    !--
    ! "NAMELIST#history_file_io_nml" is loaded in this procedure. 
    !++
    !

    ! ⥸塼 ; USE statements
    !

    ! gtool5 netCDF ǡϥ󥿡ե (絬ϥǥ)
    ! Interface of Input/Output of gtool5 netCDF data (For large models)
    !
    use gtool_historyauto, only: HistoryAutoCreate, &
      & HistoryAutoAddAttr, HistoryAutoAddWeight, HistoryAutoPutAxis

    ! ե
    ! File I/O support
    !
    use dc_iounit, only: FileOpen

    ! ʸ
    ! Character handling
    !
    use dc_string, only: CPrintf

    ! ̷ѥ᥿
    ! Kind type parameter
    !
    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output

    use timeset, only: TimeInt, TimeDisp


    ! ʸ ; Declaration statements
    !
    implicit none
    
    !ѿ
    real(8), intent(in)      :: RestartTime
    character(*), intent(in) :: cfgfile


    !-----------------------------------------------------------
    ! ҥȥ꡼
    !-----------------------------------------------------------
    call HistoryAutoCreate(                          &
      & title = exptitle,                            &
      & source = expsrc,                             &
      & institution = expinst,                       &
      & dims=(/'x','z','t'/),                        &
      & dimsizes=(/FileNX, FileNZ, 0/),              &
      & longnames=(/'x-coordinate',                  &
      &             'z-coordinate',                  &
      &             'time        '/),                &
      & units=(/'m  ','m  ','sec'/),                 &
      & xtypes=(/'double', 'double', 'double'/),     &
      & origin  = RestartTime,                       & 
      & terminus = RestartTime + TimeInt,            &
      & interval = TimeDisp,                         &       
      & file_prefix = DefaultFilePrefix,             & 
      & namelist_filename = cfgfile)  

!      & quiet=.true.,                                &
!      & start_date = InitialDate,                    &
!      & flag_mpi_split  = .true.,                    &


    call HistoryAutoAddAttr( &
      & varname = 'x', attrname = 'standard_name', &   ! (in)
      & value = 'x-coordinate' )                       ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'z', attrname = 'standard_name', &   ! (in)
      & value = 'z-coordinate' )                       ! (in)
    
    call HistoryAutoPutAxis('x', x_X(FileXMin: FileXMax))
    call HistoryAutoPutAxis('z', z_Z(FileZMin: FileZMax))

    !  ; Print
    !
!    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
!    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
    
  end subroutine HistoryFileAutoOpen


  subroutine HistoryFileAutoClose
    !
    ! ҥȥǡեϤνλԤޤ. 
    !
    ! Terminate history data files output. 

    ! ⥸塼 ; USE statements
    !

    ! gtool4 netCDF ǡϥ󥿡ե (絬ϥǥ)
    ! Interface of Input/Output of gtool4 netCDF data (For large models)
    !
    use gtool_historyauto, only: HistoryAutoClose

    ! ʸ ; Declaration statements
    !
    implicit none

    ! ѿ
    ! Work variables
    !

    ! ¹ʸ ; Executable statement
    !

    call HistoryAutoClose

  end subroutine HistoryFileAutoClose


end module HistoryAutoFileIO
